#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_rsql.pl
#
# Changes:
# 
#   bb 13Dec00 - Initial
# =========================================================

$P = "dbamon_ora_rsql.pl";
$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};
$sqlfile = $ARGV[0];
$debug = 0;
$tmpfl = "/opt/dbamon/tmp/${P}_$$.txt";

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = @_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date dbamon_ora_rsql  | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = @_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
# Main
#------------------------------------------------------------------------------

&msg("Starting - ORACLE_SID=$os sqlfile=$sqlfile");

$sqlstmts = `cat $sqlfile`; 
chop($sqllines = `wc -l $sqlfile | awk '{ print \$1 }'`); 

chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);

system("sqlplus dbamon/$passwd <<! > $tmpfl 2>&1
  $sqlstmts;
!");

if (system("grep ORA $tmpfl") == 0)
{
  system("cat $tmpfl");
  &error("SQL Error(s) Encountered");
}

$debug = 1;
&msg("Done - Processed $sqllines lines in $sqlfile");
system("rm $tmpfl");

exit 0;
